#!bin/php -q
<?
set_time_limit(0);
$passwd_file = "/etc/passwd";  // raq: /etc/passwd
$shadow_file = "/etc/shadow";  // raq: /etc/shadow
$httpd_conf = "/etc/httpd/conf/httpd.conf";  // raq: /etc/httpd/conf/httpd.conf
$mail_lhn = "/etc/sendmail.cw";     // raq: /etc/sendmail.cw
$mail_virtusertable = "/etc/virtusertable"; // raq: /etc/virtusertable
$mail_aliases = "/etc/aliases";  // raq: /etc/aliases
$dns_records = "/etc/named/records"; // raq: /etc/named/records
$base_path = "/home/sites";  // raq: /home/sites
$site_dir = "site";         // raq: site
$quota = "/usr/bin/quota"; // raq: /usr/sbin/quota
$tar = "/bin/tar";         // raq: /bin/tar

$migration_dir = "/home/migration";
$migration_info_file = "migration_info";

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////

function rf($file){
  $fp = fopen ($file, "r");
  $content = fread($fp, filesize($file));
  fclose($fp);
  clearstatcache();
  return $content;
}

function wf($file, $content){
  $fp = fopen ($file, "w");
  fwrite($fp,$content);
  fclose($fp);
}

function af($file, $content){
  $fp = fopen ($file, "a");
  fwrite($fp,$content);
  fclose($fp);
}

function no_comments($file, $comment = '#'){
  $content = str_replace("\r\n", "\n", rf($file));
  $lines = explode("\n", $content);
  if(!empty($lines)){
    foreach($lines as $line){
      if(strstr($line, $comment)){
        $pos = strpos($line, $comment);
        if($pos != 0){
          $new_lines[] = substr($line,0,$pos);
        } else {
          $new_lines[] = "";
        }
      } else {
        $new_lines[] = $line;
      }
    }
  }
  if(is_array($new_lines)){
    $content_without_comments = implode("\n", $new_lines);
    $new_lines = NULL;
    return $content_without_comments;
  } else {
    return "";
  }
}

function quota($object, $art = '-u'){
  global $quota;
  //$art: -u|-g
  $q = shell_exec($quota." ".$art." ".$object);
  if(trim($q) != ""){
    $lines = explode("\n", $q);
    if(sizeof($lines) >= 3){
      while(strstr(trim($lines[2]), "  ")){
        $lines[2] = str_replace("  ", " ", trim($lines[2]));
      }
      $qs = explode(" ", $lines[2]);
      return round($qs[2]/1024);
    } else {
      return "-1";
    }
  } else {
    return "-1";
  }
}
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
$wd = trim(realpath('./'));
if(!is_dir($migration_dir)) mkdir($migration_dir, 0755);

///////// raq-Shells in normale Shells bersetzen ///////
$shell_tr['/bin/badsh'] = '/bin/false';
///////// raq-Shells in normale Shells bersetzen ENDE ///////

/////////////// Passwrter auslesen ////////////////
$shadow_content = no_comments($shadow_file);
$lines = explode("\n", $shadow_content);
if(is_array($lines)){
  foreach($lines as $line){
    if(trim($line) != ""){
      list($username,$password,$f3,$f4,$f5,$f6,$f7,$f8,$f9) = explode(":", $line);
      $passwort[$username] = $password;
    }
  }
}
/////////////// Passwrter auslesen ENDE ////////////////

/////////////// Email-Aliasse auslesen ////////////////
$virtusers = no_comments($mail_virtusertable);
$lines = explode("\n", str_replace("\t", " ", $virtusers));
if(is_array($lines)){
  foreach($lines as $line){
    if(trim($line) != ""){
      while(strstr(trim($line), "  ")){
        $line = str_replace("  ", " ", trim($line));
      }
      list($email,$user) = explode(" ", $line);
      if(!strstr($user, "@")){
        list($alias,$domain) = explode("@", $email);
        $email_alias[$user][] = $alias;
      }
    }
  }
}
/////////////// Email-Aliasse auslesen ENDE ////////////////

/////////////// Email-Weiterleitungen auslesen ////////////
$forwards = no_comments($mail_aliases);
$lines = explode("\n", str_replace("\t", " ", $forwards));
if(is_array($lines)){
  foreach($lines as $line){
    if(trim($line) != ""){
      list($user,$forward) = explode(":", $line);
      $forward = trim($forward);
      if(strstr($forward, "@")){
        $email_forward[$user][] = $forward;
      }
    }
  }
}
/////////////// Email-Weiterleitungen auslesen ENDE ////////////

/////////////// User auslesen ////////////////
$passwd_content = no_comments($passwd_file);
$lines = explode("\n", $passwd_content);
if(is_array($lines)){
  $i = 0;
  foreach($lines as $line){
    if(trim($line) != ""){
      list($username,$x,$userid,$groupid,$realname,$home,$shell) = explode(":", $line);
      if(isset($shell_tr[$shell])) $shell = $shell_tr[$shell];
      if(substr($home,0,strlen($base_path)) == $base_path){
        // wenn Datei .ftphelp vorhanden, ist der User Siteadmin
        if(is_file($home."/.ftphelp")){
          $siteadmin = 1;
        } else {
          $siteadmin = 0;
        }
        clearstatcache();
        $web_id = str_replace($base_path."/".$site_dir, "", $home);
        $web_id = explode("/", $web_id);
        $web_id = $web_id[0];
        $users[$i][$web_id]["username"] = $username;
        $users[$i][$web_id]["x"] = $x;
        $users[$i][$web_id]["userid"] = $userid;
        $users[$i][$web_id]["groupid"] = $groupid;
        $users[$i][$web_id]["realname"] = $realname;
        $users[$i][$web_id]["home"] = $home;
        $users[$i][$web_id]["shell"] = $shell;
        $users[$i][$web_id]["password"] = $passwort[$username];
        //$users[$i][$web_id]["web_id"] = $web_id;
        $users[$i][$web_id]["siteadmin"] = $siteadmin;
        $users[$i][$web_id]["email_alias"] = $email_alias[$username];
        $users[$i][$web_id]["email_forward"] = $email_forward[$username];
        $users[$i][$web_id]["quota"] = quota($username);
        if(!is_dir($users[$i][$web_id]["home"])) unset($users[$i]);
        $i++;
      }
    }
  }
}
unset($passwort);
unset($email_alias);
unset($email_forward);
/////////////// User auslesen ENDE ////////////////

/////////////// Webs auslesen ////////////////
/*
if(is_dir($base_path)){
  $handle=@opendir($base_path);
  while ($file = @readdir ($handle)) {
      if ($file != "." && $file != "..") {
          //echo "$file\n";
          if(is_link($base_path."/".$file)){
            //echo @readlink($base_path."/".$file)."\n";
          }
      }
  }
  @closedir($handle);
}
*/

preg_match_all("'<VirtualHost[^>]*?>.*?</VirtualHost>'si",no_comments($httpd_conf, $comment = '#'),$sites);

if(is_array($sites[0])){
  $i = 0;
  foreach($sites[0] as $site){
    $lines = explode("\n", $site);
    $ip_address = trim(str_replace(">", "", str_replace("<VirtualHost", "", $lines[0])));
    $webs[$i]["ip_address"] = $ip_address;
    foreach($lines as $line){
      while(strstr(trim($line), "  ")){
        $line = str_replace("  ", " ", trim($line));
      }
      $parts = explode(" ", $line);
      if($parts[0] == "DocumentRoot"){
        $webs[$i][$parts[0]] = trim(str_replace($parts[0], "", $line));
        $web_id = str_replace($base_path."/".$site_dir, "", $webs[$i][$parts[0]]);
        $web_id = explode("/", $web_id);
        $web_id = $web_id[0];
        $webs[$i]["web_id"] = $web_id;
        if(is_numeric($web_id)) $webs[$i]["quota"] = quota("site".$web_id, "-g");
        foreach($users as $user){
          if(is_array($user[$web_id])) $webs[$i]["users"][] = $user[$web_id];
        }
      }
      if($parts[0] == "ServerName"){
        $server_name = trim(str_replace($parts[0], "", $line));
        $hds = explode(".", $server_name);
        if(sizeof($hds) >= 3){
          $host = $hds[0];
          $domain = substr($server_name, strlen($host)+1);
        } else {
          $host = "";
          $domain = $server_name;
        }
        $webs[$i][$parts[0]]["host"] = $host;
        $webs[$i][$parts[0]]["domain"] = $domain;
      }
      if($parts[0] == "ServerAlias"){
        $server_aliases = explode(" ", trim(str_replace($parts[0], "", $line)));
        $j = 0;
        foreach($server_aliases as $server_alias){
          $hds = explode(".", $server_alias);
          if(sizeof($hds) >= 3){
            $host = $hds[0];
            $domain = substr($server_alias, strlen($host)+1);
          } else {
            $host = "";
            $domain = $server_alias;
          }
          $webs[$i][$parts[0]][$j]["host"] = $host;
          $webs[$i][$parts[0]][$j]["domain"] = $domain;
          $j++;
        }
      }
      $webs[$i]["ftp"] = 1;
      $webs[$i]["cgi"] = 1;
      $webs[$i]["php"] = 1;
      $webs[$i]["ssi"] = 1;
    }
    if(!is_dir($base_path."/".$site_dir.$web_id)){
      unset($webs[$i]);
    } else {
      echo "Compressing ".$base_path."/".$site_dir.$web_id.". This might take a while...\n";
      exec("cd ".$base_path."; ".$tar." -pczf ".$site_dir.$web_id.".tar.gz ".$site_dir.$web_id."; mv -f ".$site_dir.$web_id.".tar.gz ".$migration_dir."; cd ".$wd);
    }
    $i++;
  }
}
/////////////// Webs auslesen ENDE ////////////////

if(is_file($dns_records)){
  $records = no_comments($dns_records);
  if(trim($records) != ""){
    $lines = explode("\n", trim($records));
    $i = 0;
    foreach($lines as $line){
      if(trim($line) != ""){
        while(strstr(trim($line), "  ")){
          $line = str_replace("  ", " ", trim($line));
        }
        list($type,$host,$domain,$feld4,$feld5) = explode(" ", $line);
        if(!strstr($domain, "/")){
          if($host == "-") $host = "";
          switch ($feld4) {
            case "Very-High":
              $feld4 = 10;
            break;
            case "High":
              $feld4 = 30;
            break;
            case "Low":
              $feld4 = 70;
            break;
            case "Very-Low":
              $feld4 = 90;
            break;
          }
          if($feld5 == "-") $feld5 = "";
          switch ($type) {
            case "a":
              $dns[$domain][$type][$i]["host"] = $host;
              $dns[$domain][$type][$i]["ip_address"] = $feld4;
            break;
            case "mx":
              $dns[$domain][$type][$i]["host"] = $host;
              $dns[$domain][$type][$i]["priority"] = $feld4;
              $dns[$domain][$type][$i]["mailserver"] = $feld5;
            break;
            case "cname":
              $dns[$domain][$type][$i]["host"] = $host;
              $dns[$domain][$type][$i]["ziel_host"] = $feld4;
              $dns[$domain][$type][$i]["ziel_domain"] = $feld5;
            break;
            case "ptr":
              $dns[$domain][$type][$i]["host"] = $host;
              $dns[$domain][$type][$i]["ip_address"] = $feld4;
            break;
            case "soa":
              list($ns1,$f2,$adminmail,$refresh,$retry,$expire,$ttl) = explode(":", $feld4);
              $dns[$domain][$type][$i]["ns1"] = $ns1;
              $dns[$domain][$type][$i]["adminmail"] = $adminmail;
              $dns[$domain][$type][$i]["refresh"] = $refresh;
              $dns[$domain][$type][$i]["retry"] = $retry;
              $dns[$domain][$type][$i]["expire"] = $expire;
              $dns[$domain][$type][$i]["ttl"] = $ttl;
            break;
          }
          $i++;
        }
      }
    }
  }
}
$raq["webs"] = $webs;
$raq["dns"] = $dns;
wf($migration_dir."/".$migration_info_file, serialize($raq));
//print_r(unserialize(rf($migration_dir."/".$migration_info_file)));
$import_webs_contents = '#!/root/42go/php/php -q
<?
include("/home/adm42go/42go/lib/config.inc.php");
$dbclass = $go_info["server"]["classes_root"] . $go_info["server"]["dir_trenner"] ."42go_db_".$go_info["server"]["db_type"].".lib.php";
include_once($dbclass);
$dbname = \'db_\'.$go_info["server"]["db_type"];
$db = new $dbname;
$wd = trim(realpath(\'./\'));
if(substr($wd,-1) == "/") $wd = substr($wd,0,-1);

function rf($file){
  $fp = fopen ($file, "r");
  $content = fread($fp, filesize($file));
  fclose($fp);
  clearstatcache();
  return $content;
}

function apache_user(){
  exec("ps -ef | grep httpd | grep -v 42go_httpd | grep -v grep", $apache_users);
  if(!empty($apache_users)){
    unset($apache_users[(sizeof($apache_users)-1)]);
    unset($apache_users[0]);

    foreach($apache_users as $apache_user){
      while(strstr($apache_user, "  ")){
        $apache_user = str_replace("  ", " ", $apache_user);
      }
      $apache_arr = explode(" ", $apache_user);
      if($apache_arr[0] != "root" && $apache_arr[0] != "adm42go") $apache["user"][] = $apache_arr[0];
    }

    $check = 0;
    for($i=0;$i<sizeof($apache["user"]);$i++){
      if($apache["user"][0] != $apache["user"][$i]) $check += 1;
    }
    if($check == 0){
      $apache_user = $apache["user"][0];
    } else {
      $apache_user = "root";
    }
  } else {
      $apache_user = "root";
  }
  return $apache_user;
}

if(!is_file($go_info["server"]["temp_dir"]."/import_undo.sql")) die();
$undo_sql = rf($go_info["server"]["temp_dir"]."/import_undo.sql");

$server_info = $db->queryOneRecord("SELECT * FROM isp_server WHERE doc_id = 1");
if(is_array($server_info)){
  $httpd_root = $server_info["server_path_httpd_root"];
  if(!is_dir($httpd_root)) die();
  if(substr($httpd_root,-1) == "/") $httpd_root = substr($httpd_root,0,-1);
  $root_dir = dirname($httpd_root);
  if(substr($root_dir,-1) == "/") $root_dir = substr($root_dir,0,-1);

  // symbolischen Link "sites" setzen
  if(!is_link($root_dir."/sites") && !is_file($root_dir."/sites") && !is_dir($root_dir."/sites")) symlink($httpd_root, $root_dir."/sites");

  // Hole Daten
  $filename = "migration_info";
  $contents = rf($filename);

  $contents = unserialize(stripslashes($contents));

  $web_records = $contents["webs"];
  unset($contents);
  if(is_array($web_records)){
    foreach($web_records as $web_record){
      if(is_numeric($web_record["web_id"])){
        $web_id_old = $web_record["web_id"];
        if(trim($web_record["ServerName"]["host"]) == ""){
          $web_name = $web_record["ServerName"]["domain"];
        } else {
          $web_name = $web_record["ServerName"]["host"].".".$web_record["ServerName"]["domain"];
        }
        $web_ordner_neu = readlink($httpd_root."/".$web_name);
        if(substr($web_ordner_neu,-1) == "/") $web_ordner_neu = substr($web_ordner_neu,0,-1);
        $web_id_neu = trim(str_replace($httpd_root."/web", "", $web_ordner_neu));
        if(strstr($undo_sql, \'DELETE FROM isp_isp_web where doc_id = \'.$web_id_neu.\' ;\')){

          // symbolische Links erstellen
          if(!is_link($httpd_root."/site".$web_id_old) && !is_file($httpd_root."/site".$web_id_old) && !is_dir($httpd_root."/site".$web_id_old)) symlink($web_ordner_neu, $httpd_root."/site".$web_id_old);
          if(!is_link($web_ordner_neu."/certs") && !is_file($web_ordner_neu."/certs") && !is_dir($web_ordner_neu."/certs")) symlink($web_ordner_neu."/ssl", $web_ordner_neu."/certs");
          if(!is_link($web_ordner_neu."/logs") && !is_file($web_ordner_neu."/logs") && !is_dir($web_ordner_neu."/logs")) symlink($web_ordner_neu."/log", $web_ordner_neu."/logs");
          if(!is_link($web_ordner_neu."/users") && !is_file($web_ordner_neu."/users") && !is_dir($web_ordner_neu."/users")) symlink($web_ordner_neu."/user", $web_ordner_neu."/users");

          // Site-Archiv entpacken
          exec("cd $wd; tar xvfz site$web_id_old.tar.gz &> /dev/null");

          // hat das Web einen admin-User?
          $admin_user = $db->queryOneRecord("SELECT * FROM isp_nodes, isp_dep, isp_isp_user WHERE isp_dep.parent_doc_id = \'".$web_id_neu."\' AND isp_dep.parent_doctype_id = \'1013\' AND isp_dep.child_doc_id = isp_isp_user.doc_id AND isp_dep.child_doctype_id = \'1014\' AND isp_isp_user.user_admin = \'1\' AND isp_nodes.doc_id = isp_isp_user.doc_id AND isp_nodes.doctype_id = \'1014\' AND isp_nodes.status = \'1\'");
          if(is_array($admin_user)){
            exec("chown -R ".$admin_user["user_username"].":web".$web_id_neu." ".$wd."/site".$web_id_old);
          } else {
            $apache_user = apache_user();
            exec("chown -R ".$apache_user.":web".$web_id_neu." ".$wd."/site".$web_id_old/web);
          }

          // Dateien kopieren
          exec("cp -frp $wd/site$web_id_old/certs/* $web_ordner_neu/ssl &> /dev/null");
          exec("cp -frp $wd/site$web_id_old/users/* $web_ordner_neu/user &> /dev/null");
          exec("cp -frp $wd/site$web_id_old/web/cgi-bin/* $web_ordner_neu/cgi-bin &> /dev/null");
          exec("rm -fr $wd/site$web_id_old/web/cgi-bin &> /dev/null");
          exec("rm -f $web_ordner_neu/web/index.html &> /dev/null");
          exec("cp -frp $wd/site$web_id_old/web/* $web_ordner_neu/web &> /dev/null");

          exec("rm -fr $wd/site$web_id_old &> /dev/null");
        }
      }
    }
  }
}
/////////////// Datenbanken importieren
system("which mysql", $ret_val);
if($ret_val > 0) die("Could not find program mysql on the server!");
$db_server = $go_info["server"]["db_host"];
$db_user = $go_info["server"]["db_user"];
$db_password = $go_info["server"]["db_password"];
$link = mysql_connect($db_server, $db_user, $db_password)
  or die("Could not connect to MySQL database.");
$db_list = mysql_list_dbs($link);
while ($row = mysql_fetch_object($db_list)) {
    $dbases[] = $row->Database;
}

if(is_dir($wd.\'/sql\')){
  $handle = opendir($wd.\'/sql\');
  while($file = readdir ($handle)) {
    if ($file != "." && $file != "..") {
      if(substr($file,-4) == ".sql"){
        $new_db = substr($file,0,-4);
      }
      if($new_db == "mysql"){
        if(trim($db_password) == ""){
          exec("mysql -h $db_server -u $db_user -f $new_db < $wd/sql/$file &> /dev/null");
        } else {
          exec("mysql -h $db_server -u $db_user -p$db_password -f $new_db < $wd/sql/$file &> /dev/null");
        }
        mysql_select_db("mysql");
        mysql_query(\'FLUSH PRIVILEGES\');
      } else {
        if(in_array($new_db, $dbases)){
          echo "Database ".$new_db." does already exist!\n";
        } else {
          mysql_create_db($new_db);
          if(trim($db_password) == ""){
            exec("mysql -h $db_server -u $db_user $new_db < $wd/sql/$file &> /dev/null");
          } else {
            exec("mysql -h $db_server -u $db_user -p$db_password $new_db < $wd/sql/$file &> /dev/null");
          }
        }
      }
    }
  }
  closedir($handle);
}
mysql_close($link);
?>';
wf($migration_dir."/import_webs.php", $import_webs_contents);
exec("chmod 744 $migration_dir/import_webs.php");
mkdir($migration_dir."/sql", 0755);

////////////////////
function getInput($length = 255) {
  $fr = fopen("php://stdin", "r");
  $input = fgets($fr, $length);
  $input = rtrim($input);
  fclose($fr);
  return $input;
}

echo "You can also transfer your MySQL databases to your new server. Do you want to do this? [y/n] ";
$answer = trim(getInput());

if($answer == "y"){
  echo "Please enter a MySQL user and password that has access to all MySQL databases.\n User:";
  $db_user = trim(getInput());
  echo "Password:";
  $db_password = trim(getInput());
  if($link = mysql_connect("localhost", $db_user, $db_password)){

    $db_list = mysql_list_dbs();
    $i = 0;
    $cnt = mysql_num_rows($db_list);
    while ($i < $cnt) {
      $out = '';
      $database = mysql_db_name($db_list, $i);
      mysql_select_db($database);

      $res = mysql_list_tables($database);
      $nt = mysql_num_rows($res);

      for($a=0;$a<$nt;$a++){
        $row = mysql_fetch_row($res);
        $tablename = $row[0];

        if($database != "mysql") $out .= "DROP TABLE IF EXISTS `".$tablename."`;\n";
        //$res2 = mysql_query('SHOW CREATE TABLE '.$database.'.'.$tablename);
        //$tmpres = mysql_fetch_array($res2);
        //$out .= str_replace("\n", "", $tmpres[1]);
        //$out .= ";\n\n";
        /////////////////////////
    if($database != "mysql"){
    $schema_create = 'CREATE TABLE '.$tablename.' (' . "\n";
        $local_query = 'SHOW FIELDS FROM ' .$database. '.' .$tablename;
        $result = mysql_query($local_query);
        while ($row = mysql_fetch_array($result)) {
            $schema_create     .= '   '.$row['Field'].' ' . $row['Type'];
            if (isset($row['Default']) && $row['Default'] != '') {
                $schema_create .= ' DEFAULT \'' .$row['Default']. '\'';
            }
            if ($row['Null'] != 'YES') {
                $schema_create .= ' NOT NULL';
            }
            if ($row['Extra'] != '') {
                $schema_create .= ' ' . $row['Extra'];
            }
            $schema_create .= ',' . "\n";
        } // end while
        mysql_free_result($result);
        $schema_create = ereg_replace(','."\n".'$', '', $schema_create);

        $local_query = 'SHOW KEYS FROM ' .$database.'.'.$tablename;
        $result = mysql_query($local_query);
        while($row = mysql_fetch_array($result))
        {
            $kname    = $row['Key_name'];
            $comment  = (isset($row['Comment'])) ? $row['Comment'] : '';
            $sub_part = (isset($row['Sub_part'])) ? $row['Sub_part'] : '';

            if ($kname != 'PRIMARY' && $row['Non_unique'] == 0) {
                $kname = "UNIQUE|$kname";
            }
            if ($comment == 'FULLTEXT') {
                $kname = 'FULLTEXT|$kname';
            }
            if (!isset($index[$kname])) {
                $index[$kname] = array();
            }
            if ($sub_part > 1) {
                $index[$kname][] = $row['Column_name'].'(' . $sub_part . ')';
            } else {
                $index[$kname][] = $row['Column_name'];
            }
        } // end while
        mysql_free_result($result);

        while (list($x, $columns) = @each($index)) {
            $schema_create     .= ','."\n";
            if ($x == 'PRIMARY') {
                $schema_create .= '   PRIMARY KEY (';
            } else if (substr($x, 0, 6) == 'UNIQUE') {
                $schema_create .= '   UNIQUE ' . substr($x, 7) . ' (';
            } else if (substr($x, 0, 8) == 'FULLTEXT') {
                $schema_create .= '   FULLTEXT ' . substr($x, 9) . ' (';
            } else {
                $schema_create .= '   KEY ' . $x . ' (';
            }
            $schema_create     .= implode($columns, ', ') . ')';
        } // end while
        unset($index);
        $schema_create .= "\n".');'."\n\n";
        $out .= $schema_create;
        }
    ////////////////////////
        $res2 = mysql_query("SELECT * FROM $tablename");
        $nf = mysql_num_fields($res2);
        $nr = mysql_num_rows($res2);
        for ($c=0;$c<$nr;$c++){
          $row = mysql_fetch_row($res2);
          $out .= "INSERT INTO `$tablename` (";
          for($d=0;$d<$nf;$d++) {
            $field = mysql_field_name($res2, $d);
            $out .= $field;
            if($d<($nf-1)){
              $out .=", ";
            }
          }
          $out .= ") VALUES (";
          for($d=0;$d<$nf;$d++) {
            $data = strval($row[$d]);
            if(is_null($row[$d])){
              $out .="NULL";
            } else {
              $out .="'".mysql_escape_string($data)."'";
            }
            if($d<($nf-1)){
              $out .=", ";
            }
          }
          $out .=");\n";
        }
      }
      wf($migration_dir."/sql/".$database.".sql", $out);
      $i++;
    }
  } else {
    echo "Could not connect to MySQL database!\n";
  }
}
////////////////////

echo "Creating migration file. This might take a while...\n";
exec("cd ".dirname($migration_dir)."; ".$tar." -pczf migration.tar.gz ".basename($migration_dir)."; rm -fr ".$migration_dir."; cd ".$wd);
echo "Done!\n";
echo "You can find your migration file under /home. It is called migration.tar.gz.\n";
?>